﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using ViewManager.Model;
using System.Windows.Data;

namespace ViewManager.Controls
{
    public partial class BackGround : UserControl
    {


        public byte R
        {
            get { return (byte)GetValue(RProperty); }
            set { SetValue(RProperty, value); }
        }

        // Using a DependencyProperty as the backing store for R.  
        // This enables animation, styling, binding, etc...
        public static readonly DependencyProperty RProperty =
            DependencyProperty.Register("R",
                                        typeof(byte),
                                        typeof(BackGround),
                                        new PropertyMetadata((byte)0,
                                            new PropertyChangedCallback(OnRChanged)));

        static void OnRChanged(object sender, DependencyPropertyChangedEventArgs args)
        {
            // Get reference to self
            BackGround source = (BackGround)sender;

            // Add Handling Code
            //byte newValue = (byte)args.NewValue;
            source.changeColor();
        }



        public byte G
        {
            get { return (byte)GetValue(GProperty); }
            set { SetValue(GProperty, value); }
        }

        // Using a DependencyProperty as the backing store for G.  
        // This enables animation, styling, binding, etc...
        public static readonly DependencyProperty GProperty =
            DependencyProperty.Register("G",
                                        typeof(byte),
                                        typeof(BackGround),
                                        new PropertyMetadata((byte)0,
                                            new PropertyChangedCallback(OnGChanged)));

        static void OnGChanged(object sender, DependencyPropertyChangedEventArgs args)
        {
            // Get reference to self
            BackGround source = (BackGround)sender;

            // Add Handling Code
            //byte newValue = (byte)args.NewValue;
            source.changeColor();
        }



        public byte B
        {
            get { return (byte)GetValue(BProperty); }
            set { SetValue(BProperty, value); }
        }

        // Using a DependencyProperty as the backing store for B.  
        // This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BProperty =
            DependencyProperty.Register("B",
                                        typeof(byte),
                                        typeof(BackGround),
                                        new PropertyMetadata((byte)0,
                                            new PropertyChangedCallback(OnBChanged)));

        static void OnBChanged(object sender, DependencyPropertyChangedEventArgs args)
        {
            // Get reference to self
            BackGround source = (BackGround)sender;

            // Add Handling Code
            //byte newValue = (byte)args.NewValue;
            source.changeColor();
        }



        private ColorAnimation colorAnim;
        private Storyboard storyboard;

        public BackGround()
        {
            InitializeComponent();

            storyboard = new Storyboard();
            Brush br = this.LayoutRoot.Background;
            colorAnim = new ColorAnimation();
            colorAnim.To = Color.FromArgb(255, R, G, B);
            colorAnim.Duration = TimeSpan.FromSeconds(1);
            colorAnim.RepeatBehavior = new RepeatBehavior(1);
            colorAnim.AutoReverse = false;
            Storyboard.SetTarget(colorAnim, br);
            Storyboard.SetTargetProperty(colorAnim, new PropertyPath("Color"));
            storyboard.Children.Add(colorAnim);
            Resources.Add("colorSb", storyboard);

            this.Loaded += new RoutedEventHandler(BackGround_Loaded);
        }

        void BackGround_Loaded(object sender, RoutedEventArgs e)
        {
            this.DataContext = BackGroundModel.Instance;
            Binding bindR = new Binding("R");
            bindR.Mode = BindingMode.TwoWay;
            this.SetBinding(RProperty, bindR);
            Binding bindG = new Binding("G");
            bindG.Mode = BindingMode.TwoWay;
            this.SetBinding(GProperty, bindG);
            Binding bindB = new Binding("B");
            bindB.Mode = BindingMode.TwoWay;
            this.SetBinding(BProperty, bindB);
        }

        public void changeColor() {
            colorAnim.To = Color.FromArgb(255, R, G, B);
            storyboard.Begin();
        }
    }
}
