﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using ViewManager.Model;
using ViewManager.Converters;
using System.Windows.Data;
using ViewManager.Command;

namespace ViewManager.Controls
{
    public partial class ColorConfig : UserControl
    {
        public ColorConfig()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(ColorConfig_Loaded);

            this.BtnRandom.Click += new RoutedEventHandler(BtnRandom_Click);
        }

        void BtnRandom_Click(object sender, RoutedEventArgs e)
        {
            byte r = (byte)RNG.Next(255);
            byte g = (byte)RNG.Next(255);
            byte b = (byte)RNG.Next(255);
            new SetBGColorEvent(r, g, b).dispatch();
        }

        void ColorConfig_Loaded(object sender, RoutedEventArgs e)
        {
            this.DataContext = BackGroundModel.Instance;
            ByteConverter bc = new ByteConverter();
            Binding bindR = new Binding("R");
            bindR.Mode = BindingMode.TwoWay;
            bindR.Converter = bc;
            xRSlider.SetBinding(Slider.ValueProperty, bindR);
            Binding bindG = new Binding("G");
            bindG.Mode = BindingMode.TwoWay;
            bindG.Converter = bc;
            xGSlider.SetBinding(Slider.ValueProperty, bindG);
            Binding bindB = new Binding("B");
            bindB.Mode = BindingMode.TwoWay;
            bindB.Converter = bc;
            xBSlider.SetBinding(Slider.ValueProperty, bindB);
        }
    }
}
